function PathBuilder(path, pathViewer) {
		
	if (!this.path)
		this.path = path;
	
	if (!this.pathViewer)
		this.pathViewer = pathViewer;
	
	if (this.path.sides)
		this.buildedSides = this.path.sides;
	
	this.drawSpecialZones();
	this.createTriggers();
	
	return this;
	
};

	PathBuilder.prototype.path = null;
	PathBuilder.prototype.pathViewer = null;
		
	PathBuilder.prototype.lastX = null;
	PathBuilder.prototype.lastY = null;
	
	PathBuilder.prototype.buildingState = null;
	PathBuilder.prototype.buildedSides = 0;
	
	PathBuilder.prototype.drawSpecialZones = function() {
		
		this.pathViewer.drawBuildingZones();
		
	};
	
	PathBuilder.prototype.createTriggers = function() {
		
		var $this = this;
		var startZone = this.pathViewer.getStartZone();
		var drivingZone = this.pathViewer.getDrivingZone();
		var endZone = this.pathViewer.getEndZone();
		var ocanvas = this.pathViewer.getCanvas();
		
		startZone.bind("click tap", function(e){
			if ($this.buildingState == "startline") {
				$this.buildStartLine(e);
			} else {
				$this.startBuildingLines(e);
			}
		});
		
		drivingZone.bind("click tap", function(e){
			if ($this.buildingState == "lines") {
				$this.addLine(e.x, e.y);
			}
		});
		
		endZone.bind("click tap", function(e){
			$this.finishBuildingLines(e);
		});
		
		ocanvas.bind("click tap", function(e){
			e.stopPropagation();
			if ($this.buildingState == "checkpoints") {
				$this.addCheckpoint(e.x, e.y);
			}
		});
		
	};
	
	PathBuilder.prototype.startBuildingLines = function(e) {

		if (this.buildingState == null && this.buildedSides < 2) {
			this.buildingState = "lines";
						
			// prepare "last point" for building
			this.lastX = e.x;
			this.lastY = this.path.getHeight(), 
			this.addLine(e.x, e.y);
		}
		
	};
	
	PathBuilder.prototype.finishBuildingLines = function(e) {
		
		if (this.buildingState == "lines" && this.buildedSides < 2) {			
			this.addLine(e.x, e.y);
			this.addLine(e.x, 0);
			
			this.buildingState = null;
			this.buildedSides++;
			this.path.sides++;
			
		}
		
	};
	
	PathBuilder.prototype.addLine = function(x, y) {
		
		this.path.addLine(parseInt(this.lastX), parseInt(this.lastY), parseInt(x), parseInt(y));
		this.pathViewer.updateView();
		
		this.lastX = x;
		this.lastY = y;
				
	};
	
	PathBuilder.prototype.addCheckpoint = function(x, y) {
		
		this.path.addCheckpoint(x, y);
		this.pathViewer.updateView();
		
	};
	
	PathBuilder.prototype.buildingCheckpoints = function() {
		
		return (this.buildingState == "checkpoints");
		
	};
	
	PathBuilder.prototype.startBuildingCheckpoints = function() {
		
		if (this.buildingState) {
			console.log("You should finish previous building state.");
			return;
		}
		this.buildingState = "checkpoints";
		
	};
	
	PathBuilder.prototype.stopBuildingCheckpoints = function() {
		
		this.buildingState = null;
		
	};
	
	PathBuilder.prototype.startBuildingStartLine = function() {
		
		if (this.buildingState != null) {
			console.log("Finish started building state.");
			return;
		}
		
		if (this.path.startLine != null) {
			console.log("Startline already exists!");
			return;
		}
				
		this.buildingState = "startline";
				
	};
	
	PathBuilder.prototype.buildStartLine = function(e) {
				
		if (!this.startLineX) {
			this.startLineX = e.x;
			this.startLineY = e.y;
		} else {
			this.path.setStartLine(this.startLineX, this.startLineY, e.x, e.y);
			this.pathViewer.updateView();
			this.buildingState = null;
		}
		
	};
	